function love.load()
	 ps = getPS('assets/particles/smoke', love.graphics.newImage('assets/img/particle-smoke.png'))
	 ps:start() 
    ps:setPosition(0, 0)
	
	love.mouse.setVisible(false)
	points = 0
	enemyValue = 50
	life = 100
	

	
	font = love.graphics.newFont('assets/fnt/Unibody8Pro-RegularSmallCaps.otf', 14) -- the number denotes the font size
	love.graphics.setFont(font)
	
	-- Loading the audio files.
	--bgm01 = love.audio.newSource('assets/snd/bgm3.mp3')
	--bgm01:setLooping(true)
	--bgm01:play()
	
	snd1 = love.audio.newSource("assets/snd/turret.wav", "static")
	snd2 = love.audio.newSource("assets/snd/missile-hit.wav", "static")
	snd3 = love.audio.newSource("assets/snd/missile-ground.wav", "static")
	snd4 = love.audio.newSource("assets/snd/missile-launch.wav", "static")
	
	--bg
	love.graphics.setBackgroundColor( 29, 36, 42 )
	
   
	--city 1
	
	city1 = {}
	city1.width = 40
	city1.height = 20
	city1.health = 3
	city1.bg = love.graphics.newImage('assets/img/city-1.png')
	
	--city 2
	
	city2 = {}
	city2.width = 40
	city2.height = 20
	city2.health = 3
	city2.bg = love.graphics.newImage('assets/img/city-2.png')
	
	
	--turret
	
	
	
	turret = {}
	turret.bg = love.graphics.newImage('assets/img/barrel.png')
	turret.x = 399
	turret.y = 479
	turret.width = 30
    turret.height = 2
	turret.angle = math.rad(-90)
	
	
	
	--corsair
	
	corsair = {}
	corsair.x = 200
	corsair.y = 200
	corsair.width = 9
    corsair.height = 9

	--bullets
	bullet = {}
	bullet.speed = 350
	bullet.bg = love.graphics.newImage('assets/img/bullet.png')
	bullet.angle = turret.angle
	
	bullets = {}
	
	--rate of fire
	
	can_fire = true --If true player can shoot
	fire_wait = 0.15 --Delay between shots in seconds
	fire_tick = 0 --Used to count the seconds
	
	
	--enemies variables
	maxEnemies = 5
	currentEnemies = 0
	
	canSpawn = true
	spawnWait = 1
	spawnCounter = 0
	
	spawnPointMax = 760
	spawnPointMin = 20
	targetPointMax = 760
	targetPointMin = 20
	
	enemy = {}
	enemy.speed = 50
	enemy.bg = love.graphics.newImage('assets/img/missile.png')
	enemy.angle = math.rad(90)
	enemy.width = 35
	enemy.height = 8
	
	enemies = {}
	
	
end

function love.update(dt)

	ps:update(dt)

	--cursor position
	
	local mouseX = love.mouse.getX();
	local mouseY = love.mouse.getY();
	if(mouseY <= 493) then
		corsair.x = mouseX-4
		corsair.y = mouseY-4
	end
	
	--turret position facing the cursor
	
	turret.angle = math.atan2(mouseY-turret.y, mouseX-turret.x)
	bullet.angle = turret.angle

	
	--creating the tables for bullets and enemies removal
	local rem_enemy = {}
	local rem_shot = {}
	
	--enemy drawing
	
	if not canSpawn then
		spawnCounter = spawnCounter + dt --Increases fire_tick by dt each frame which results in fire_tick increasing by 1 roughly every second
		if spawnCounter > spawnWait then
			canSpawn = true
			spawnCounter = 0
		end
	end
	
	if canSpawn then
		if currentEnemies < maxEnemies then
			
			--enemies get into their table
			
			snd4:play()
			snd4:rewind()
			
			local spawnX = love.math.random( spawnPointMin, spawnPointMax )
			local targetX = love.math.random( targetPointMin, targetPointMax )
			
			local enemyAngle = math.atan2((498 - -20), (targetX - spawnX))
			
			local enemyWidth = enemy.width
			local enemyHeight = enemy.height
			
			local enemyDx = enemy.speed * math.cos(enemyAngle)
			local enemyDy = enemy.speed * math.sin(enemyAngle)
			
			table.insert(enemies,
							{
								x = spawnX,
								y = -20,
								dx = enemyDx,
								dy = enemyDy,
								angle = enemyAngle,
								width = enemyWidth,
								height = enemyHeight
							}
						)
			currentEnemies = currentEnemies + 1
			canSpawn = false
		end
	end
	-- moving enemies
	
	for i,v in ipairs(enemies) do
        v.x = v.x + (v.dx * dt)
        v.y = v.y + (v.dy * dt)
		
		--ground hit
		
		if v.y > 492 - v.height then
			snd3:play()
			snd3:rewind()
			table.insert(rem_enemy, i)
			
			--damage
			if life > 0 then
				life = life - 10
			end
		end
		
    end
	
	
	for i,v in ipairs(bullets) do
        v.x = v.x + (v.dx * dt)
        v.y = v.y + (v.dy * dt)
		
		--mark for removal
		if v.y < 0 then
            table.insert(rem_shot, i)
        end
		if v.y > 498 then
            table.insert(rem_shot, i)
        end
		if v.x < 0 then
            table.insert(rem_shot, i)
        end
		if v.x > 800 then
            table.insert(rem_shot, i)
        end
		
		-- check for collision with enemies
        for ii,vv in ipairs(enemies) do
            if CheckCollision(v.x,v.y,2,5,vv.x,vv.y,vv.width/2,vv.height/2) then

				snd2:play()
				snd2:rewind()

				points = points + enemyValue
                -- mark that enemy for removal
                table.insert(rem_enemy, ii)
                -- mark the shot to be removed
                table.insert(rem_shot, i)

            end
        end
    end
	
	
	--shooting
	if not can_fire then
		fire_tick = fire_tick + dt --Increases fire_tick by dt each frame which results in fire_tick increasing by 1 roughly every second
		if fire_tick > fire_wait then
			can_fire = true
			fire_tick = 0
		end
	end

	if can_fire then
		if love.mouse.isDown('l') then	
			snd1:play()
			local startX = turret.x + 1
			local startY = turret.y 
			  
			local mouseX = love.mouse.getX();
			local mouseY = love.mouse.getY();
			
			local angle = math.atan2((mouseY - startY), (mouseX - startX))
			
			local bulletDx = bullet.speed * math.cos(angle) 
			local bulletDy = bullet.speed * math.sin(angle) 
			
			table.insert(bullets, 
							{
								x = startX, 
								y = startY, 
								dx = bulletDx, 
								dy = bulletDy, 
								angle = bullet.angle 
							}
						)

		end
		can_fire = false
	end
	
	--remove enemies and bullets from their tables
	
	for i,v in ipairs(rem_shot) do
        table.remove(bullets, v)
    end
	
	for i,v in ipairs(rem_enemy) do
		
		currentEnemies = currentEnemies - 1
        table.remove(enemies, v)
    end

	
	
end

function love.draw()

	

	
	--ground
	love.graphics.setColor( 215, 229, 241 )
    love.graphics.rectangle("fill", 0, 498, 800, 50)  
	 
	--drawing enemies
	
	love.graphics.setColor(226,0,26,255)
    for i,v in ipairs(enemies) do
		love.graphics.draw(enemy.bg, v.x, v.y, v.angle, 1, 1, v.width/2, v.height/2)
		--smoke trail(particles)

		love.graphics.draw(ps, v.x, v.y, v.angle, 1, 1, 23, 0)
    end
	
	--bullets
	
	love.graphics.setColor( 255, 255, 255 )
    for i,v in ipairs(bullets) do
		love.graphics.draw(bullet.bg, v.x, v.y, v.angle, 1, 1, 0, 1)
    end
	
	--gun barrel 
	love.graphics.setColor( 255, 255, 255 )
	love.graphics.draw(turret.bg, turret.x+1, turret.y, turret.angle, 1, 1, 0, 1)
	
	--turret base
	love.graphics.setColor( 215, 229, 241 )
	love.graphics.arc( "fill", 400, 498, 20, 0, -math.pi )
	
	-- city 1
	love.graphics.setColor( 255, 255, 255 )
	love.graphics.draw(city1.bg, 130, 478, 0, 1, 1)
	
	-- city 2
	love.graphics.setColor( 255, 255, 255 )
	love.graphics.draw(city2.bg, 180, 478, 0, 1, 1)
	
	
	--corsair 
	
	love.graphics.setColor( 215, 229, 241 )
	love.graphics.rectangle("line", corsair.x, corsair.y, corsair.width, corsair.height)
	
	
	--stripe
	love.graphics.setColor( 215, 229, 241 )
	love.graphics.rectangle("fill", 0, 548, 800, 50)  
	
	
	--points
	love.graphics.setColor(30,37,43)
	love.graphics.print(points, 30, 565)
	
	--healthbar
	love.graphics.setColor(30,37,43)
	love.graphics.rectangle("line", 668, 570, 102, 17)  
	
	love.graphics.setColor(226,0,26,255)
	love.graphics.rectangle("fill", 669, 571, life, 15)  
	
end

-- Collision detection function.
-- Checks if a and b overlap.
-- w and h mean width and height.
function CheckCollision(ax1,ay1,aw,ah, bx1,by1,bw,bh)

  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

function love.keyreleased(key)
	if key == 'escape' then
        love.event.push('quit') -- Quit the game.
    end 
end


function love.quit()
end

function getPS(name, image)
    local ps_data = require(name)
    local particle_settings = {}
    particle_settings["colors"] = {}
    particle_settings["sizes"] = {}
    for k, v in pairs(ps_data) do
        if k == "colors" then
            local j = 1
            for i = 1, #v , 4 do
                local color = {v[i], v[i+1], v[i+2], v[i+3]}
                particle_settings["colors"][j] = color
                j = j + 1
            end
        elseif k == "sizes" then
            for i = 1, #v do particle_settings["sizes"][i] = v[i] end
        else particle_settings[k] = v end
    end
    local ps = love.graphics.newParticleSystem(image, particle_settings["buffer_size"])
    ps:setAreaSpread(string.lower(particle_settings["area_spread_distribution"]), particle_settings["area_spread_dx"] or 0 , particle_settings["area_spread_dy"] or 0)
    ps:setBufferSize(particle_settings["buffer_size"] or 1)
    local colors = {}
    for i = 1, 8 do 
        if particle_settings["colors"][i][1] ~= 0 or particle_settings["colors"][i][2] ~= 0 or particle_settings["colors"][i][3] ~= 0 or particle_settings["colors"][i][4] ~= 0 then
            table.insert(colors, particle_settings["colors"][i][1] or 0)
            table.insert(colors, particle_settings["colors"][i][2] or 0)
            table.insert(colors, particle_settings["colors"][i][3] or 0)
            table.insert(colors, particle_settings["colors"][i][4] or 0)
        end
    end
    ps:setColors(unpack(colors))
    ps:setColors(unpack(colors))
    ps:setDirection(math.rad(particle_settings["direction"] or 0))
    ps:setEmissionRate(particle_settings["emission_rate"] or 0)
    ps:setEmitterLifetime(particle_settings["emitter_lifetime"] or 0)
    ps:setInsertMode(string.lower(particle_settings["insert_mode"]))
    ps:setLinearAcceleration(particle_settings["linear_acceleration_xmin"] or 0, particle_settings["linear_acceleration_ymin"] or 0, 
                             particle_settings["linear_acceleration_xmax"] or 0, particle_settings["linear_acceleration_ymax"] or 0)
    if particle_settings["offsetx"] ~= 0 or particle_settings["offsety"] ~= 0 then
        ps:setOffset(particle_settings["offsetx"], particle_settings["offsety"])
    end
    ps:setParticleLifetime(particle_settings["plifetime_min"] or 0, particle_settings["plifetime_max"] or 0)
    ps:setRadialAcceleration(particle_settings["radialacc_min"] or 0, particle_settings["radialacc_max"] or 0)
    ps:setRotation(math.rad(particle_settings["rotation_min"] or 0), math.rad(particle_settings["rotation_max"] or 0))
    ps:setSizeVariation(particle_settings["size_variation"] or 0)
    local sizes = {}
    local sizes_i = 1 
    for i = 1, 8 do 
        if particle_settings["sizes"][i] == 0 then
            if i < 8 and particle_settings["sizes"][i+1] == 0 then
                sizes_i = i
                break
            end
        end
    end
    if sizes_i > 1 then
        for i = 1, sizes_i do table.insert(sizes, particle_settings["sizes"][i] or 0) end
        ps:setSizes(unpack(sizes))
    end
    ps:setSpeed(particle_settings["speed_min"] or 0, particle_settings["speed_max"] or 0)
    ps:setSpin(math.rad(particle_settings["spin_min"] or 0), math.rad(particle_settings["spin_max"] or 0))
    ps:setSpinVariation(particle_settings["spin_variation"] or 0)
    ps:setSpread(math.rad(particle_settings["spread"] or 0))
    ps:setTangentialAcceleration(particle_settings["tangential_acceleration_min"] or 0, particle_settings["tangential_acceleration_max"] or 0)
    return ps
end